<?php
  ini_set('memory_limit', '512M');  
  $session = $this->getSession();
  $filter_html = new Yab_Filter_Html();
  
  $sitefouille_id = $session->get('sitefouille_id') ;
  
  $option_height = (!empty($option_height) ) ? $option_height : '400px' ;

  $network = array(
    'nodes' => array(),
    'edges' => array(),  
  ) ;
  $network_nodes = array() ;
  $network_edges = array() ;
  
  // Node Racine
  $network['nodes'][0] = array(
    'id' => 0,
    'label' => '', // Racine
    // 'allowedToMoveY' => 'false',
    'title' => '',
    'color' => array ( 'background' => '#FFFFFF' ),
    'shape' => 'box',
    'level' => 0,
    'root' => 0,
    'parent' => 0,
    'poid' =>  1,      
  );  
  
  /**
   *  Thèse de Bruno DESACHY
   *  De la formalisation du traitement des données stratigraphiques en archéologie de terrain
   *  volume 1 : aperçu historiographique - notes méthodologiques
   *  3.1.4. Le choix d'une structure de codage et de traitement : la matrice d'adjacence
   *
   * $matrice_relation_us[ma_ligne][ma_colonne] = array ( 'token' => 0, 'poid' => 0)
   * $matrice_relation_us[us_anterieur][us_posterieur] = array ( 'token' => 0, 'poid' => 0)
   *       
   */       
  $matrice_relation_us = array() ;    
  foreach($network_anteroposterite as $key_anteroposterite => $value_anteroposterite ) {
    
    $poid = $value_anteroposterite->get('poid') ; 
    
    $us_id_p = $value_anteroposterite->get('posterieur_id') ;
    $us_nom_p =  str_replace("/", "<br>" ,$value_anteroposterite->get('us_posterieur') ) ;
    $us_id_ident_p = hash('crc32', $us_id_p ) ;    
    $title_p = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_p.'\')">D&eacute;tails</a>' ;
    $color_p = '#'.substr(hash('crc32', $value_anteroposterite->get('us_posterieur_contexte') ), -6 ) ;
    $level_p = $value_anteroposterite->get('level_posterieur') ;
    $level_p = (!empty($network['nodes'][$us_id_p]['level'] ) ) ? $network['nodes'][$us_id_p]['level'] + $level_p : $level_p ; 
    
    
    $poid_p = $value_anteroposterite->get('us_posterieur_link') ;
    
    $us_id_a = $value_anteroposterite->get('anterieur_id') ;
    $us_nom_a = str_replace("/", "<br>" ,$value_anteroposterite->get('us_anterieur') ) ;
    $us_id_ident_a = hash('crc32', $us_id_a ) ;  
    $title_a = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_a.'\')">D&eacute;tails</a>' ;
    $color_a = '#'.substr( hash('crc32', $value_anteroposterite->get('us_anterieur_contexte') ), -6 ) ;
    // $level_a = $value_racine->get('level_anterieur') ;
    $level_a = (!empty($network['nodes'][$us_id_a]['level'] ) ) ?  $network['nodes'][$us_id_a]['level'] +1 : $level_p + 1 ;
    $poid_a = $value_anteroposterite->get('us_anterieur_link') ;
    
    $matrice_relation_us[$us_id_a][$us_id_p]['token'] = 1 ;
    $matrice_relation_us[$us_id_a][$us_id_p]['level'] = 1 ;
    // $matrice_relation_us[$us_nom_a][$us_nom_p]['token'] = 1 ;
    // $matrice_relation_us[$us_nom_a][$us_nom_p]['level'] = 1 ;
    
    if (!isset($matrice_relation_us[$us_id_p]) ){ $matrice_relation_us[$us_id_p] = array() ;    }
    
    $network['nodes'][$us_id_p] = array(
      'id' => $us_id_ident_p,
      'label' => $us_nom_p,
      // 'allowedToMoveY' => 'false',
      'title' => $title_p,
      'color' => array ( 'background' => $color_p ),
      'shape' => 'box',
      'level' => $level_p,
      'root' => $us_id_p,
      'parent' => 0,
      'poid' =>  $poid_p,      
    );
     
    $network['nodes'][$us_id_a] = array(
      'id' => $us_id_ident_a,
      'label' => $us_nom_a,
      // 'allowedToMoveY' => 'false',
      'title' => $title_a,
      'color' => array ( 'background' => $color_a ),
      'shape' => 'box', 
      'level' => $level_a,
      'root' => $us_id_p,
      'parent' => $us_id_p,
      'poid' =>  $poid_a,
    );
   
    $edges = array(
      'from' => $us_id_ident_p,
      'to' => $us_id_ident_a,
      'style' => 'arrow',
      'root' => $us_id_p,
      'parent' => $us_id_p,
      'level' => $level_p,
      'poid' =>  $poid,     
    );

    $network['edges'][$us_id_p] = $edges ;

    
  }

  foreach($network_synchronisation as  $key_synchro => $synchronisation ) {
    $us_id_l = $synchronisation->get('synchro1_id') ;
    $us_nom_l = str_replace("/", "<br>" ,$synchronisation->get('us_left_synchro')) ;
    $us_id_ident_l = hash('crc32', $us_id_l ) ;
    $title_l = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_l.'\')">D&eacute;tails</a>' ;
    $color_l = '#'.substr(hash('crc32', $synchronisation->get('us_left_contexte') ), -6 ) ;
    
    $parent_l = (!empty($network['nodes'][$us_id_l]['parent'])) ?  $network['nodes'][$us_id_l]['parent'] : 0 ;
    $level_l = (!empty($network['nodes'][$parent_l]['level'] )) ? $network['nodes'][$parent_l]['level'] + 1 : 1 ;
    
    
    $us_id_r = $synchronisation->get('synchro2_id') ;
    $us_nom_r = str_replace("/", "<br>" ,$synchronisation->get('us_right_synchro')) ;
    $us_id_ident_r = hash('crc32', $us_id_r ) ;  
    $title_r = '<a href="#" onClick="showDetailUsNetwork(\''.$us_id_r.'\')">D&eacute;tails</a>' ;
    $color_r = '#'.substr(hash('crc32', $synchronisation->get('us_right_contexte') ), -6 ) ;
    
    $parent_r = (!empty($network['nodes'][$us_id_r]['parent'])) ?  $network['nodes'][$us_id_r]['parent'] : 0 ;
    $level_r = (!empty( $network['nodes'][$parent_r]['level'] )) ?  $network['nodes'][$parent_r]['level'] + 1 : 1 ; 
    
    $poid = $synchronisation->get('poid') ;
    
    $matrice_relation_us[$us_id_r][$us_id_l]['token'] = 10 ;
    $matrice_relation_us[$us_id_r][$us_id_l]['level'] = 1 ;
    // $matrice_relation_us[$us_nom_r][$us_nom_l]['token'] = 10 ;
    // $matrice_relation_us[$us_nom_r][$us_nom_l]['level'] = 1 ;
    
    if (!isset($matrice_relation_us[$us_id_l]) ){ $matrice_relation_us[$us_id_l] = array() ; }
    /*
    if (!isset($matrice_relation_us[$us_nom_l][$us_nom_r]) ){ 
      $matrice_relation_us[$us_nom_l][$us_nom_r] = array (
        'token' => 0, 
        'poid' => 0,
      ) ; 
    }
    */
    

    $poid_l =  (!empty($network['nodes'][$us_id_l]['poid'])) ?  $network['nodes'][$us_id_l]['poid'] + 1 : $poid + 1  ; 
    $racine_id = (!empty($network['nodes'][$us_id_l]['root'])) ?  $network['nodes'][$us_id_l]['root'] : $us_id_l ; 
    
    $level = ($level_l >= $level_r ) ? $level_l : $level_r ;
    
    // $network['nodes'][$us_id_l]['level'] = $level ;
    // $network['nodes'][$us_id_r]['level'] = $level ;
    
    
    if ( !empty($network['nodes'][$us_id_l] ) ) {
      $racine_id = $network['nodes'][$us_id_l]['root'] ;
      
      $network['nodes'][$us_id_l]['poid'] = $poid_l ;
      $network['nodes'][$us_id_l]['level'] = $level ;
             
    } else {
      $network['nodes'][$us_id_l] = array(
        'id' => $us_id_ident_l,
        'label' => $us_nom_l,
        // 'allowedToMoveY' => 'false',
        'title' => $title_l,
        'color' => array ( 'background' => $color_l ),
        'shape' => 'box',
        'level' => $level,       
        'root' => $racine_id,
        'parent' => $parent_l,
        'poid' =>  $poid_l,     
      );    
    }
    $network['nodes'][$racine_id]['poid'] = $poid_l ;

    if ( !empty($network['nodes'][$us_id_r] ) ) {
    
      $network['nodes'][$us_id_r]['poid'] = $poid_l ;
       $network['nodes'][$us_id_r]['level'] = $level ;
       
    } else {
      $network['nodes'][$us_id_r] = array(
        'id' => $us_id_ident_r,
        'label' => $us_nom_r,
        // 'allowedToMoveY' => 'false',
        'title' => $title_r,
        'color' => array ( 'background' => $color_r ),
        'shape' => 'box',
        'level' => $level,       
        'root' => $racine_id,
        'parent' => $parent_r,
        'poid' =>  $poid_l,     
      );    
    }
    $network['nodes'][$racine_id]['poid'] = $poid_l ;
    
    $edges = array(
      'from' => $us_id_ident_l,
      'to' => $us_id_ident_r,
      // 'color' => 'red',
      'length' => 50,
      'root' => $racine_id,
      'parent' => $parent_l,
      'level' => $level,
      'poid' =>  $poid_l, 

    );

    $network['edges'][$us_id_l] = $edges ;

  } 

  /**
   *  3.2.1. Traitement des synchronismes – notion d’ensemble synchrone
   *  =>Déduction des synchronismes non enregistrés par symétrie et transitivité
   */
  // tri le tableau 
  ksort($matrice_relation_us);
  
  foreach($matrice_relation_us as $key_relation_us => $value_relation_us ) {
    $us_anterieur = $key_relation_us ;
    $relation_us = $value_relation_us ;
    
    foreach($relation_us as $key_us => $value_us ) {
      $us_posterieur = $key_us ;
      $token = $value_us['token'] ;
      $level = $value_us['level'] ;
      // Test si la relation correspondant à un synchronisme
      if ($token == 10){
        $token = 19 ;
        // si matrice(i,j) = s , alors matrice(j,i) = s ;
        // et si matrice(j,k) = s, alors matrice(i,k) = s.
        $matrice_relation_us[$us_anterieur][$us_posterieur]['token'] = $token ;
        $matrice_relation_us[$us_posterieur][$us_anterieur]['token'] = $token ;
        if (!isset($matrice_relation_us[$us_posterieur][$us_anterieur]['level']) ) {
          $matrice_relation_us[$us_posterieur][$us_anterieur]['level'] = 0 ;
        }        
        // chaque US synchrone i l’apparition d’une relation réflexive matrice(i,i) = s
        $matrice_relation_us[$us_anterieur][$us_anterieur]['token'] = $token ;
        if (!isset($matrice_relation_us[$us_anterieur][$us_anterieur]['level']) ) {
          $matrice_relation_us[$us_anterieur][$us_anterieur]['level'] = 0 ;
        }        
        $matrice_relation_us[$us_posterieur][$us_posterieur]['token'] = $token ;
        if (!isset($matrice_relation_us[$us_posterieur][$us_posterieur]['level']) ) {
          $matrice_relation_us[$us_posterieur][$us_posterieur]['level'] = 0 ;
        }        
        
        // si une US i est synchrone avec une US j, et si j est antérieure à une US k, alors i est antérieure à k.
        array_walk($matrice_relation_us[$us_posterieur], function(&$value, &$key){
            // if you want to change array values then "&" before the $value is mandatory.
          if(isset($matrice_relation_us[$key] ) ){
            $poid = $matrice_relation_us[$key]['level'] ;
            $token = $matrice_relation_us[$key]['token'] ;
            $matrice_relation_us[$us_anterieur][$key]['level'] = $level ;
            $matrice_relation_us[$us_anterieur][$key]['token'] = $token ;
            // unset($matrice_relation_us[$key]);            
          }              
        });
                            
      }

    }
    
  }
  /**
   * 3.2.2. Traitement des relations d’ordre
   *    Notion de distance stratigraphique
   */
  $matrice_relation_us_new = $matrice_relation_us ;
  $level_us = array () ;
  foreach($matrice_relation_us as $key_relation_us => $value_relation_us ) {
    $us_anterieur = $key_relation_us ;
    $relation_us = $value_relation_us ;
    $matrice_relation = distances_stratigraphiques($matrice_relation_us, $us_anterieur ) ;
    $matrice_relation_us = $matrice_relation['matrice'] ;
    $dst = $matrice_relation['dst'] ;
    $level_us[$us_anterieur] = $dst + 1 ;
    
    /**
     * Attribution du niveau à l'US
     */
     $network['nodes'][$us_anterieur]['level'] = 5 - $dst ;           
     if (isset($network['edges'][$us_anterieur]) ) { $network['edges'][$us_anterieur]['level'] = 5 - $dst ; }
     
  }      
  /*
  print '<pre>' ;
  print_r($network['nodes']);
  print '</pre>' ;  
  */            
  foreach($network['nodes'] as $node ) {
    $racine_id = $node['root'] ;
    $racine_poid = $network['nodes'][$racine_id]['poid'] ;
    $node['poid'] = $racine_poid ; 
    
    $parent_id = $node['parent'] ;
    $level = $network['nodes'][$parent_id]['level'] + 1 ;
    $node['level'] = $level ;
         
    $network_nodes[] = $node ;
  } 
  
  foreach($network['edges'] as $edge ) {
    $racine_id = $edge['root'] ;
    $racine_poid = $network['edges'][$racine_id]['poid'] ;
    $edge['poid'] = $racine_poid ; 
    $network_edges[] = $edge ;
  } 

  function distances_stratigraphiques($matrice, $k ){
    $distances_dst = array(0,) ;
    
    // pour i,j,k appartenant à l’ensemble des US traitées,
    // si matrice(i,j) > 0, et si matrice(j,k) > 0, et si matrice(i,k) < matrice(j,k) + 1,
    // alors matrice(i,k) = matrice(j,k) + 1.
    foreach($matrice as $i => $value_i ) {
      $relation = $value_i ;
      if(is_array($relation) ){
        foreach($relation as $j => $value_j ) {
          $level_i_j = (!empty($value_j['level']) ) ? $value_j['level'] : 0 ;
          if( isset($matrice[$j]) && isset($matrice[$j][$k]) && isset($matrice[$j][$k]['level']) ) {
            $level_j_k = $matrice[$j][$k]['level'] ;
            $level_i_k = (isset($matrice[$i][$k]['level']) ) ? $matrice[$i][$k]['level'] : 0 ;
            // print '<div><span> ['.$i.','.$j.'] : '.$level_i_j.' </span><span> ['.$j.','.$k.'] : '.$level_j_k.' </span><span> ['.$i.','.$k.'] : '.$level_i_k.'</span>' ;             
            if (  ($level_i_j > 0) && ($level_j_k > 0 ) && ( $level_i_k < $level_j_k +1) ){
              $class = 'class="label label-success"';
              $matrice[$i][$k]['level'] = $matrice[$j][$k]['level'] + 1 ;
                               
            } else {
              $class = '' ;
            }
            // distance stratigraphique totale Dst.
            $level_i_k = (isset($matrice[$i][$k]['level']) ) ? $matrice[$i][$k]['level'] : 0 ;
            
            array_push($distances_dst, $level_i_k) ;
            // print '<span> ['.$i.','.$j.'] i : '.$matrice[$i][$j]['level'].' </span><span> ['.$j.','.$k.'] j : '.$matrice[$j][$k]['level'].' </span><span '.$class.'> ['.$i.','.$k.'] k : '.$level_i_k.'</span></div>' ;     
          }
          
        }
      }
      
    }
    
    return array ('matrice' => $matrice, 'dst' => max($distances_dst) ) ;
      
  } 
     
  function array_orderby()
  {
      $args = func_get_args();
      $data = array_shift($args);
      foreach ($args as $n => $field) {
          if (is_string($field)) {
              $tmp = array();
              foreach ($data as $key => $row)
                  $tmp[$key] = $row[$field];
              $args[$n] = $tmp;
              }
      }
      $args[] = &$data;
      call_user_func_array('array_multisort', $args);
      return array_pop($args);
  }
  
  $network_nodes = array_orderby($network_nodes, 'level', SORT_ASC, 'poid', SORT_DESC, 'root', SORT_ASC ) ;
  
  $network_edges = array_orderby($network_edges, 'level', SORT_ASC, 'poid', SORT_DESC ) ;
  
  $network_nodes = json_encode($network_nodes,  JSON_UNESCAPED_SLASHES  )  ;
  $network_edges = json_encode($network_edges )  ;

  // identifiant unique de la div d'affichage 
  $unique_div = rand();
  
  // redirection de page Plein ecran / Dashboard
  
  $controller = $this->getRequest()->getController();
  $action = $this->getRequest()->getAction() ;
  $controller_action = $controller.'_'.$action ; 
  if ( $controller_action == 'Dashboard_show' ) {
    $redict_url = $this->getRequest('Dashboard_Us', 'UsNetwork', array('layout' => 1, 'height' => '600px' )) ;
    $redict_glyph = 'glyphicon glyphicon-resize-full' ;
    $redict_tooltip = 'Mettre en plein &eacute;cran ' ;
    
  } else {
    $redict_url = $this->getRequest('Dashboard', 'show') ;
    $redict_glyph = 'glyphicon glyphicon-resize-small' ;
    $redict_tooltip = 'Revenir au tableau de bord ' ;
  }

?>
  <style type="text/css">
    #sdf_us_network {
      /* width: 600px; 
      height: 400px;
      border: 1px solid lightgray;
      */
    }

  </style>
<div class="col-md-12">
  <div class="panel panel-default">
    <div class="panel-heading"> Unit&eacute;s Stratigraphiques  
      <div class="pull-right">                                
        <div class="btn-group">
          <a href="<?php echo $redict_url  ; ?>" >                                    
            <button 
              class="btn btn-default btn-xs"
              data-original-title="<?php echo $redict_tooltip ; ?>"
              data-toggle="tooltip"
              data-placement="bottom"
            >      
                <span
                  class="glyphicon <?php echo $redict_glyph  ; ?>" 
                  aria-hidden="true"
                ></span>
            </button>
          </a>
        </div>                            
      </div>
      
    </div>    
    <div class="panel-body" style="background-image: url('<?php //echo $request->getBaseUrl(); ?>/images/ilot_cygne_bg.jpg') ;">
      <div id="sdf_us_network_<?php echo $unique_div  ; ?>" >chargement ... </div>
    </div>
    
  </div>
</div>


<script type="text/javascript">
    
  function showDetailUsNetwork(us_id)
  {
     $.ajax({
      type:"POST",
			url: "<?php echo $this->getRequest('Dashboard_us','Show' ) ; ?>"+us_id,
			data: "id="+us_id,
      success: function(returnData) {
        // Affichage du modal (boite de dialogue)
        $('#modalTitle').html('Unite Stratigraphique');
        $('#modalBody').html(returnData);
        $('#myModal').modal();
        if(data.error)
          alert(data.error);
       },
       error: function(returnData) {
        alert('Une erreur est survenue.'); 
       }
      });
  } 
      
    /* US Network */
    var network_us_network = null;
    var layoutMethod_us_network = "direction";
    // var layoutMethod_us_network = "hubsize";
    var direction_us_network = "UD";
    var option_height = "<?php echo $option_height ; ?>" ; 
    
    var nodes_us_network = <?php echo $network_nodes ; ?> ;
    var edges_us_network = <?php echo $network_edges ; ?> ;
    
    // console.log(nodes_us_network) ;  
    // create a network
    var container_us_network = document.getElementById('sdf_us_network_<?php echo $unique_div  ; ?>');
    var data_us_network = {
        nodes: nodes_us_network,
        edges: edges_us_network
        // dot: dot_us_network,
    };

     var options_us_network = {
      width:  "100%",
      height: option_height,
      smoothCurves:false,
      // configurePhysics:true,
      physics: {
        hierarchicalRepulsion: {
          centralGravity: 0.4
        }
      },
      hierarchicalLayout: {
        enabled: true,
        levelSeparation: 100,
        nodeSpacing: 100,
        direction: direction_us_network,
        layout: layoutMethod_us_network
      },
    };
    network_us_network = new vis.Network(container_us_network, data_us_network, options_us_network);

</script>

